/*************************************************************************************
3D Data Visualization – 3D visualization of 4 entertainments
Created Feb 10, 2020
            
Tested in Processing 3.5.1
 
Author: Jingxuan Cao                         

Instruction for Interaction:

Using mouse to drag the graph
Clicking left-hand side years to see corresponding graph

Uses the following libraries: 

 *************************************************************************************/

import java.util.*;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import peasy.*;


PeasyCam cam;

final List<Integer> gen_music = new ArrayList();
final  List<Integer> Ind_game = new ArrayList();
final  List<Integer> Sports = new ArrayList();
final  List<Integer> Shows = new ArrayList();

//color of general music orange
color stroke_c1 = color(237, 101, 26);
color fill_c1 = color(237, 122, 59, 40);
//color of indoor game blue
color stroke_c2 = color(26, 61, 237);
color fill_c2 = color(26, 128, 237, 40);
//color of sports 
color stroke_c3 = color(160, 26, 237);
color fill_c3 = color(237, 26, 233, 40);
//color of shows green
color stroke_c4 = color(86, 237, 26);
color fill_c4 = color(167, 237, 26, 40);

int x1, y1, x2, y2, wid_circle, hei_circle;
Table table;
int rows;
boolean []_polygons;

void setup() {
  size(displayWidth, displayHeight, P3D);
  set_Camera();
  loadData();
  _polygons = new boolean[]{true, true, true, true, true, true, true, true, true ,true, true, true ,true, true};
}

void draw() {
  background(0);
  
  
  

  int distance = 0;
  int month_c = 0;
  // i < 4 setCamera: Z = 5000, distance = 5000
  
  for (int i = 0; i < 14; i++) { 
    //println("month_c: ", month_c);
    push();
    translate(0, 0, distance);
    radarMap(Sports, month_c, month_c+11, stroke_c3, fill_c3, _polygons[i]);
    pop();
    push();
    translate(0, 0, distance + 50);
    radarMap(Shows, month_c, month_c+11, stroke_c4, fill_c4, _polygons[i]);
    pop();
    push();
    translate(0, 0, distance + 100);
    radarMap(Ind_game, month_c, month_c+11, stroke_c2, fill_c2, _polygons[i]);
    pop();
    push();
    translate(0, 0, distance + 150);
    radarMap(gen_music, month_c, month_c+11, stroke_c1, fill_c1, _polygons[i]);
    pop();
    
    month_c += 12;
    distance += 200;
    
  }
  
  translate(0,0,distance);
  //month text
  fill(255);
  font = createFont("Arial",30);
  textFont(font);
  textSize(70);
  int text_pos = hei_circle + 50;
  text("Jan", x1+(text_pos/2)*sin(PI/6) , y1 - text_pos/2*cos(PI/6));
  text("Feb", x1+(text_pos/2)*sin(PI/3), y1 - text_pos/2*cos(PI/3));
  text("Mar", x1 + text_pos/2, y1);
  text("Apr", x1+(text_pos/2)*sin(PI/3), y1 + text_pos/2*cos(PI/3));
  text("May", x1+(text_pos/2)*sin(PI/6), y1 + text_pos/2*cos(PI/6));
  text("Jun", x1, y1 + text_pos/2);
  text("Jul", x1-(text_pos/2)*sin(PI/6), y1 + text_pos/2*cos(PI/6));
  text("Aug", x1-(text_pos/2)*sin(PI/3), y1 + text_pos/2*cos(PI/3)); 
  text("Sep", x1 - text_pos/2, y1 ); 
  text("Oct", x1-(text_pos/2)*sin(PI/3), y1 - text_pos/2*cos(PI/3) ); 
  text("Nov", x1-(text_pos/2)*sin(PI/6), y1 - text_pos/2*cos(PI/6) ); 
  text("Dec", x1, y1 - text_pos/2); 
  
  
  mytext();
}
